package activefarm;

import java.util.HashMap;
import java.util.Map;

import org.ercim.gridcomp.component.autonomic.manager.itf.AutonomicServerManager;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ProActiveContentController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;


public class Main {
	
	 public void action() throws Exception {

		 Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
	     Map context = new HashMap();
	     
	     System.out.println();
	     System.out.println("------------------------------------");
	     System.out.println("|          Active Manager          |");
	     System.out.println("------------------------------------");
	     System.out.println();
	     System.out.println("User NF requirement: job can't be enqueued ");
	     System.out.println("for more than 3.5 seconds and less than 3.005 seconds");
	     System.out.println();
	     
	     Component testcase = (Component) f.newComponent("activefarm.adl.application", context);
	        
	    
	     ProActiveContentController testcaseCC = Fractive.getProActiveContentController(testcase);
	        Component[] testcaseInternalComponents = testcaseCC.getFcSubComponents();
	        
	        ProActiveComponent Cmp = null;
	        AutonomicServerManager asm = null;
	        for(Component cmp : testcaseInternalComponents){
	        	
	        	NameController nc = (NameController) cmp.getFcInterface(Constants.NAME_CONTROLLER);
	        	
	        	if(nc.getFcName().equals("stage")){
	        		 
	        	    Cmp = (ProActiveComponent) cmp;	
	        	}
	     
	        }
	        
	        
	        ProActiveContentController CmpCC = Fractive.getProActiveContentController(Cmp);
	        Component[] CmpInternalComponents = CmpCC.getFcSubComponents();
	        for(Component cmp : CmpInternalComponents){
	        	
	        	NameController nc = (NameController) cmp.getFcInterface(Constants.NAME_CONTROLLER);
	        	
	        	if(nc.getFcName().equals("automan")){
	        		asm = (AutonomicServerManager) cmp.getFcInterface(AutonomicServerManager.COMMIT_CONTRACT_ITF_NAME);     
	        	}
	        
	        }
	        
	        asm.commitContract(3005+","+3500);
	        Fractal.getLifeCycleController(testcase).startFc();
	     
	}
	
	public static void main(String[] args) {
		 Main test = new Main();
	        try {
	            test.action();
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	}

}
