package activefarm.autonomic_elements;

import java.util.Vector;

import org.ercim.gridcomp.component.autonomic.manager.AbstractAutonomicManager;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public class FarmificationAutonomicManager extends AbstractAutonomicManager {

	boolean initialized = false;
	
	private long min = 3005;
	private long max = 3500;
	
	@SuppressWarnings("unchecked")
	@Override
	protected void enforcePerformanceContract(String qosContract) {
		
		if(qosContract != null){
			String[] s = qosContract.split(",");
			min = Long.parseLong(s[0]);
			min = Long.parseLong(s[1]);
		}
		
		if(!initialized){
			
			managedAutonomicController.execOperation( "JobEnqueuingTime", new Object[]{new Boolean(true)} );
			initialized = true;
		}
		
		GenericTypeWrapper obsMethods = 
			managedAutonomicController.execOperation( "JobEnqueuingTime", new Object[0] );
		
		String[] observedMethods = (String[]) obsMethods.getObject();
		
		if(observedMethods != null)
			for(String s : observedMethods){
				
				GenericTypeWrapper methodValue = managedAutonomicController.execOperation("JobEnqueuingTime", (Object[]) new String[]{s});
				Long averageValue = (Long) methodValue.getObject();
				
				System.out.println("Current enqueuing average is : "+averageValue);
				if(averageValue > max){
					out("Parallel degree increasing needed");
					GenericTypeWrapper res = 
						managedAutonomicController.execOperation("increaseParallelDegree", new Object[0]);
					if((Boolean)((Vector<Object>)res.getObject()).elementAt(0)){
						System.out.println("INCREASING SUCCEEDED, the current number of worker is : "+((Vector<Object>)res.getObject()).elementAt(1));
					}else{
						System.out.println("INCREASING DO NOT SUCCEEDED, the current number of worker still is: "+((Vector<Object>)res.getObject()).elementAt(1));
					}
				}else if(averageValue < min){
					out("Parallel degree decreasing needed");
					GenericTypeWrapper res = 
						managedAutonomicController.execOperation("decreaseParallelDegree", new Object[0]);
					if((Boolean)((Vector<Object>)res.getObject()).elementAt(0)){
						System.out.println("DECREASING SUCCEEDED, the current number of worker is : "+((Vector<Object>)res.getObject()).elementAt(1));
					}else{
						System.out.println("DECREASING DO NOT SUCCEEDED, the current number of worker still is: "+((Vector<Object>)res.getObject()).elementAt(1));
					}
				}
			}

	}

}
