package multicusecase;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import org.ercim.gridcomp.am.controller.AutonomicController;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ProActiveContentController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import multicusecase.itf.Producer;


public class Test{
 	private static final long serialVersionUID = 1L;

	
    public static void main(String[] args) throws NoSuchInterfaceException, Exception {
    	System.setProperty("nonregressiontest.descriptor.defaultnodes.file", "/nonregressiontest/descriptor/defaultnodes/NodesLocal.xml");
        Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
        Map context = new HashMap();
        
        String actualtestcase = "";
      
        System.out.println("***********************************************************");
        System.out.println("    Use of the multicast interface example  (void results) ");
        System.out.println("***********************************************************");

        // testcase with no gathering interfaces 
        actualtestcase = new String("multicusecase.adl.testcase");
        
        Component testcase = (Component) f.newComponent(actualtestcase,context);
        
        Fractal.getLifeCycleController(testcase).startFc();
       
        ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(5000,1);
        ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(500,10);
        
        
        /* Looking up the Autonomic Controller */   
        ProActiveContentController testcaseCC = Fractive.getProActiveContentController(testcase);
        Component[] testcaseInternalComponents = testcaseCC.getFcSubComponents();
        
        int i = 0;
        boolean found = false;
        ProActiveComponent paCmp = null;
        
        while(!found){
        	Component cmp = testcaseInternalComponents[i++];
        	if(cmp instanceof ProActiveComponent){
        		ProActiveComponentRepresentative pcr = 
        			(ProActiveComponentRepresentative)((ProActiveComponent) cmp).getRepresentativeOnThis();
        		
        		if(pcr.getStubOnBaseObject() instanceof org.objectweb.proactive.core.component.type.Composite){
        			paCmp = (ProActiveComponent) testcaseInternalComponents[--i];
        			found = true;
        		}
        	}
        	
        }
        AutonomicController ac = (AutonomicController)paCmp.getFcInterface("autonomic-controller");

        /* ask for some increasing of the parallelism degree */
        BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));
        System.out.print("cmd >");
        bf.readLine();
        System.out.println(" ------> Increase Parallel Degree to 6 workers <----------");
        ac.execOperation("increaseParallelDegree", new Object[0]);
        /* and then re-execute the service */
        ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(10,1);
        System.out.print("cmd >");
        bf.readLine();
        System.out.println(" ------> Increase Parallel Degree to 7 workers <----------");
     
        ac.execOperation("increaseParallelDegree", new Object[0]);
        
        ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(100,1);

    }

}
