package multicusecase.impl;

import java.util.ArrayList;
import java.util.List;

import multicusecase.itf.MulticastTestItf;
import multicusecase.itf.Producer;
import multicusecase.impl.WrappedInteger;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;


public class ProducerImpl implements Producer, BindingController{

	MulticastTestItf clientItf;

	public void lesspower(int numtask, int size) {
		List<WrappedInteger> list = new ArrayList<WrappedInteger>();
		for (int i=0;i<size;i++){
			list.add(i, new WrappedInteger(i));
		}
		long init = System.currentTimeMillis();
		
		for (int k=0;k<numtask;k++){
			System.out.println("\n Pushing the task n."+k+" by calling the multicast interface");
			clientItf.getService(list);
			
			
		}
		long end = System.currentTimeMillis();
		System.out.println("\n All requests sent in "+(end-init)+" msec.");
	}

	public void testConnectedServerMulticastItf(int numtask, int size) {
		/* outofmemory with numtask=5000 e size=1
		 * ok with numtask=1000 e size=5
		 * i.e.:if you have to compute 5000 tasks (es. Mandelbrot), I can do streams of task with lenght 1 but
		 * I'll get outofmemory; or I can manage my stream with tasks of lenght 5, and it works
		 * But: 
		 * - no friendly (no implementation-independent)
		 * - it doen't respect the logic of the application
		 * - I must to manage parallelism by grouping tasks
		 * */
		System.out.println("Pushing in the stream num. "+numtask+" tasks ("+size+" values each):");		
		lesspower(numtask,size);
		
	}
	

	
	public void bindFc(String clientItfName, Object serverItf)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {

		if (clientItfName.equals("clientItf")) {
				clientItf = (MulticastTestItf) serverItf;
		}
		else {
			throw new NoSuchInterfaceException(clientItfName);
		}
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#listFc()
	 */
	public String[] listFc() {
		return null;
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#lookupFc(java.lang.String)
	 */
	public Object lookupFc(String clientItfName)
			throws NoSuchInterfaceException {

		if ("clientItf".equals(clientItfName)) {
			return clientItf;
		}
		
		throw new NoSuchInterfaceException(clientItfName);
		
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#unbindFc(java.lang.String)
	 */
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {

		// TODO Auto-generated method stub

	}



}
