package multicusecaseSynch;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import org.ercim.gridcomp.am.controller.AutonomicController;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ProActiveContentController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import multicusecaseSynch.itf.Producer;


public class Test{
    public static void main(String[] args) throws NoSuchInterfaceException, Exception {
    		System.setProperty("nonregressiontest.descriptor.defaultnodes.file", "/nonregressiontest/descriptor/defaultnodes/NodesLocal.xml");
            Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
            Map context = new HashMap();
            
            String actualtestcase = "";
          
            System.out.println("*******************************************************");
            System.out.println("    Use of the multicast interface example             ");
            System.out.println("*******************************************************");

            // testcase with no gathering interfaces 
            actualtestcase = new String("multicusecaseSynch.adl.testcase");
            
            Component testcase = (Component) f.newComponent(actualtestcase,context);
            
            Fractal.getLifeCycleController(testcase).startFc();
           
            // the second group of values computes faster
            ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(30,1);
            ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(2,1);
            
            
               
            ProActiveContentController testcaseCC = Fractive.getProActiveContentController(testcase);
            Component[] testcaseInternalComponents = testcaseCC.getFcSubComponents();
            
            int i = 0;
            boolean found = false;
            ProActiveComponent paCmp = null;
            
            while(!found){
            	Component cmp = testcaseInternalComponents[i++];
            	if(cmp instanceof ProActiveComponent){
            		ProActiveComponentRepresentative pcr = 
            			(ProActiveComponentRepresentative)((ProActiveComponent) cmp).getRepresentativeOnThis();
            		
            		if(pcr.getStubOnBaseObject() instanceof org.objectweb.proactive.core.component.type.Composite){
            			paCmp = (ProActiveComponent) testcaseInternalComponents[--i];
            			found = true;
            		}
            	}
            	
            }
            AutonomicController ac = (AutonomicController)paCmp.getFcInterface("autonomic-controller");
            BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));
            System.out.print("Press ENTER to increase parallelism degree >");
            bf.readLine();
            System.out.println("\n ------> Increase Parallel Degree to 6 workers <----------");
            ac.execOperation("increaseParallelDegree", new Object[0]);
            // here you could  get an OutofMemory
            // with numtask=3000 and size=1
            // with numtask=200 and size=1, you get an error on the access of the results!!! A nullpointerExce.
            //probably due to the fact that you are waiting on a future that is not readly available 
            ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(1,4);
            System.out.print("Press ENTER to increase parallelism degree >");
            bf.readLine();
            System.out.println("\n ------> Increase Parallel Degree to 7 workers <----------");
         
            ac.execOperation("increaseParallelDegree", new Object[0]);
            
            
            ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(2
            		,1);
            
    }

}
