package multicusecaseSynch.impl;

import java.util.ArrayList;
import java.util.List;

import multicusecaseSynch.itf.MulticastTestItf;
import multicusecaseSynch.itf.Producer;
import multicusecaseSynch.impl.WrappedInteger;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

public class ProducerImpl implements Producer, BindingController{

	MulticastTestItf clientItf;

	private void waiting(int dimtask, int s){
		WrappedInteger w;
		// preparing a stream of 10 tasks
		int g;
		for (int j=0;j<s;j++){
			// preparing the task
			List<WrappedInteger> list = new ArrayList<WrappedInteger>();;
			
			for (int i = 0; i <dimtask; i++) {
				w = new WrappedInteger(i+1);
				list.add(i, w);
			}
			// send the task
			List<WrappedInteger> result = clientItf.testRoundRobin_Method(list);

			System.out.println(j+") Request sent, waiting for "+result.size()+" values >> ");
			
			for (int k=0;k<result.size();k++){
				 g = result.get(k).getIntValue();
				 System.out.print(".");
			}
			System.out.println("All gotten!");
		}	
	}
	

	private void no_waiting(int dimtask, int s){
		WrappedInteger w;
		// preparing a stream of 10 tasks
		for (int j=0;j<s;j++){
			// preparing the task
			List<WrappedInteger> list = new ArrayList<WrappedInteger>();;
			for (int i = 0; i <dimtask; i++) {
				w = new WrappedInteger(i+1);
				list.add(i, w);
			}
			// send the task
			List<WrappedInteger> result = clientItf.testRoundRobin_Method(list);
			System.out.println(j+") Request sent");
		}
	}
	
	public void one_way_stream(int longstream){
		List<WrappedInteger> result=null;
		for (int i=0;i<longstream;i++){
			List<WrappedInteger> list = new ArrayList<WrappedInteger>();
			list.add(0, new WrappedInteger(5));
			System.out.println(i+") Request sent");
			result = clientItf.testRoundRobin_Method(list);
		}
		
		System.out.println(" and now read: ");
		int t=0;
		for (int h=0;h<longstream;h++)
			for (int i=0;i<result.size();i++){
				t=result.get(i).getIntValue();
			System.out.print(".");
		}
		System.out.println(" All gotten!");
	}
	
	public void lesspower(int numtask, int size){
		List<WrappedInteger> result=null;
		List<WrappedInteger> list = new ArrayList<WrappedInteger>();
		int v=0;
		for (int i=0;i<size;i++){
			list.add(i, new WrappedInteger(i));
		}
	
		List<List<WrappedInteger>> arr;
		arr = new ArrayList<List<WrappedInteger>>();
		long init = System.currentTimeMillis();
		
		for (int k=0;k<numtask;k++){
			System.out.println("\n Pushing the task n."+k+" by calling the multicast interface");

			result = clientItf.testRoundRobin_Method(list);
			arr.add(result);
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		List<WrappedInteger> r;
		for (int i=0;i<arr.size();i++){
			r =  arr.get(i);
			for (int t=0;t<r.size();t++){						
				 v = r.get(t).getIntValue();
				System.out.print(".");
			}
			
		}
		long end = System.currentTimeMillis();
		System.out.println("\n All results gotten in "+(end-init)+" msec.");
	}

	public void testConnectedServerMulticastItf(int numtask, int size) {
		/* COMMENT AND UNCOMMENT THE NEEDED CODE
		
		System.out.println("Pushing in the stream num. "+numtask+" tasks ("+size+" values each) without reading the answers:");		
		no_waiting(size,numtask);
		
		numtask = 10;
		System.out.println("Pushing in the stream num. "+numtask+" tasks ("+size+" values each) and read immediately the answers:");
		waiting(size,numtask);
		
		
		size=1;
		numtask=10;
		System.out.println("Pushing in the stream "+numtask+"("+size+" long) tasks and read the answers as soon as available:");
		waiting(size,numtask);
		
		size=1;
		numtask=20;

		System.out.println("Pushing in a stream "+numtask+" tasks ("+size+" values long) and no wait");
		no_waiting(size,numtask);
		*/
		
		System.out.println("Pushing in the stream num. "+numtask+" tasks ("+size+" values each, 2msec/value), THEN read the answers:");		
		lesspower(numtask,size);
	}
	

	
	public void bindFc(String clientItfName, Object serverItf)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {

		if (clientItfName.equals("clientItf")) {
				clientItf = (MulticastTestItf) serverItf;
		}
		else {
			throw new NoSuchInterfaceException(clientItfName);
		}
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#listFc()
	 */
	public String[] listFc() {
		return null;
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#lookupFc(java.lang.String)
	 */
	public Object lookupFc(String clientItfName)
			throws NoSuchInterfaceException {

		if ("clientItf".equals(clientItfName)) {
			return clientItf;
		}
		
		throw new NoSuchInterfaceException(clientItfName);
		
	}

	/*
	 * @see org.objectweb.fractal.api.control.BindingController#unbindFc(java.lang.String)
	 */
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {
	}



}
