package multicusecaseSynch.impl;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.ProActive;
import org.objectweb.proactive.core.UniqueID;
import testsuite.test.Assertions;
import multicusecaseSynch.impl.WrappedInteger;
import multicusecaseSynch.itf.CollectorItf;
import multicusecaseSynch.itf.ServerTestItf;
import nonregressiontest.component.Message;


public class ServerImpl implements ServerTestItf, BindingController {
    private UniqueID myid;
    
    CollectorItf clientItf;
    
    public ServerImpl(){
    		myid=ProActive.getBodyOnThis().getID();

    }
    public Message processOutputMessage(Message message) {
        return null;
    }

    public WrappedInteger testOneToOne_Param(WrappedInteger a) {

        Assertions.assertEquals(a.getIntValue(), myid);
        return new WrappedInteger(0);
    }

    
    public WrappedInteger testRoundRobin_Param(WrappedInteger a) {
    		int value = a.getIntValue();
    		int newvalue  =value;
    		try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
    		WrappedInteger w = new WrappedInteger(newvalue);
    		System.out.print(".");
    		return clientItf.collectData(w);
    		
    }

    public WrappedInteger testRoundRobin_Method(WrappedInteger a) {
    	int value = a.getIntValue();
    	int newvalue  =value;
    	try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
    	WrappedInteger w = new WrappedInteger(newvalue);
		return clientItf.collectData(w);
    }

    /*
     * @see collectiveitf.multicast.Itf1#dispatch(collectiveitf.multicast.WrappedInteger)
     */
    public WrappedInteger dispatch(WrappedInteger a) {

        return testOneToOne_Param(a);
    }

	public void bindFc(String clientItfName, Object serverItf)	throws NoSuchInterfaceException, 
																IllegalBindingException,
																IllegalLifeCycleException 
	{
		if (clientItfName.equals("CollectorItf")) {
			clientItf = (CollectorItf) serverItf;
		}
		else {
			throw new NoSuchInterfaceException(clientItfName);
		}
}

/*
* @see org.objectweb.fractal.api.control.BindingController#listFc()
*/
public String[] listFc() {
 return new String[]{"CollectorItf"};
}

/*
* @see org.objectweb.fractal.api.control.BindingController#lookupFc(java.lang.String)
*/
public Object lookupFc(String clientItfName)
	throws NoSuchInterfaceException {

	if ("CollectorItf".equals(clientItfName)) {
		return clientItf;
	}
	throw new NoSuchInterfaceException(clientItfName);
}

/*
* @see org.objectweb.fractal.api.control.BindingController#unbindFc(java.lang.String)
*/
public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
	IllegalBindingException, IllegalLifeCycleException {}
    
}
