package org.ercim.gridcomp.am.controller;

import java.io.IOException;

import javax.naming.NamingException;

import org.ercim.gridcomp.am.util.RegistrationSimplifier;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ComponentParametersController;
import org.objectweb.proactive.core.component.controller.ProActiveLifeCycleControllerImpl;
import org.objectweb.proactive.core.component.group.ProxyForComponentInterfaceGroup;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
//import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.component.type.ProActiveInterfaceType;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactory;

public class AutonomicApplicationLifeCycleControllerImpl extends
		ProActiveLifeCycleControllerImpl {

	
	private static final long serialVersionUID = 1L;

	public AutonomicApplicationLifeCycleControllerImpl(Component arg0) {
		super(arg0);
		
	}

	
	
	@Override
	public void stopFc() {
		
		System.out.println("Entro nella StopFc del supercomponente");
		
		//super.stopFc();
		try {
            String hierarchical_type = ((ComponentParametersController) getFcItfOwner()
                                        .getFcInterface(Constants.COMPONENT_PARAMETERS_CONTROLLER)).getComponentParameters()
                                        .getHierarchicalType();
            if (hierarchical_type.equals(Constants.COMPOSITE)) {
                // stop all inner components
                Component[] inner_components = ((ContentController) getFcItfOwner()
                                                                        .getFcInterface(Constants.CONTENT_CONTROLLER)).getFcSubComponents();
                
                // Recupero l'AutonomicManager
                ProActiveComponent pac_simp = null;
                ProActiveComponent pac_am = null;
                boolean inUse=false;
                try {
                	pac_simp = (ProActiveComponent) Fractive.lookup("RegistrationSimplifier");
					pac_am = (ProActiveComponent) Fractive.lookup("AutonomicManager");
					
					RegistrationSimplifier rs = 
						(RegistrationSimplifier) pac_simp.getFcInterface("server-registration-simplifier");
					
					inUse = (rs.getStartOrStopAM());
					
				} catch (IOException e) {
					e.printStackTrace();
				} catch (NamingException e) {
					e.printStackTrace();
				}
                
				System.out.println("Nella StopFc del supercomponente: ci sono "+inner_components.length+" comps");
                
                if (inner_components != null) {
                    for (int i = 0; i < inner_components.length; i++) {
                    	System.out.println("Nel for della StopFc del supercomponente: "+i);
                    	System.out.flush();
                    if( ((!((ProActiveComponent)inner_components[i]).equals(pac_am)) &&
                    	(!((ProActiveComponent)inner_components[i]).equals(pac_simp))) 
                    	|| !inUse){
                    	
                    		System.out.println(((ProActiveComponentRepresentative)((ProActiveComponent)inner_components[i]).getRepresentativeOnThis()).getStubOnBaseObject().getClass().getSuperclass());
                    		System.out.flush();
                    		((LifeCycleController) inner_components[i].getFcInterface(Constants.LIFECYCLE_CONTROLLER)).stopFc();
                    	}
                    }
                	System.out.println("Nella StopFc del supercomponente: Terminato il for degli stops");
                	System.out.flush();
                }
            }

            //getRequestQueue().stop();
            fcState = LifeCycleController.STOPPED;
           /* if (logger.isDebugEnabled()) {
                logger.debug("stopped" +
                    ((ComponentParametersController) getFcItfOwner()
                     .getFcInterface(Constants.COMPONENT_PARAMETERS_CONTROLLER)).getComponentParameters()
                     .getName());
            }*/
        } catch (NoSuchInterfaceException nsie) {
          //  logger.error("interface not found : " + nsie.getMessage());
        } catch (IllegalLifeCycleException ilce) {
          //  logger.error("illegal life cycle operation : " + ilce.getMessage());
        }
		
		
		finally{
			System.out.println("Terminata la StopFc del SuperComponente");
			System.out.flush();
		}
	}

	/*private Component findAM(Component[] inner_components) {
		
		for(Component pc : (inner_components)){
			System.err.println(">>>>>>>>>>>>>>>>>>>>>>"+pc.toString());
			System.err.println(((ProActiveComponentRepresentative) inner_components[0]).getFcType());
			
		}
		
		return inner_components[0];
	}
*/


	@Override
	public void stopFc(short arg0) {
		System.err.println("PIPPEROZZOLO");
		System.err.flush();
		//super.stopFc(arg0);
	}



	@Override
	public void startFc() {
		 try {
	            //check that all mandatory client interfaces are bound
	            //            Object[] itfs = getFcItfOwner().getFcInterfaces();
	            InterfaceType[] itfTypes = ((ComponentType) getFcItfOwner()
	                                                            .getFcType()).getFcInterfaceTypes();

	            for (int i = 0; i < itfTypes.length; i++) {
	                if (itfTypes[i].isFcClientItf() &&
	                        !itfTypes[i].isFcOptionalItf()) {
	                    if (itfTypes[i].isFcCollectionItf()) {
	                        // look for collection members
	                        Object[] itfs = owner.getFcInterfaces();
	                        for (int j = 0; j < itfs.length; j++) {
	                            Interface itf = (Interface) itfs[j];
	                            if (itf.getFcItfName()
	                                       .startsWith(itfTypes[i].getFcItfName())) {
	                                if (itf.getFcItfName()
	                                           .equals(itfTypes[i].getFcItfName())) {
	                                    throw new IllegalLifeCycleException(
	                                        "invalid collection interface name at runtime (suffix required)");
	                                }
	                                if (Fractal.getBindingController(owner)
	                                               .lookupFc(itf.getFcItfName()) == null) {
	                                    throw new IllegalLifeCycleException(
	                                        "compulsory collection client interface " +
	                                        itfTypes[i].getFcItfName() +
	                                        " in component " +
	                                        Fractal.getNameController(
	                                            getFcItfOwner()).getFcName() +
	                                        " is not bound. ");
	                                }
	                            }
	                        }
	                    } else if (((ProActiveInterfaceType) itfTypes[i]).isFcMulticastItf() &&
	                            !!itfTypes[i].isFcOptionalItf()) {
	                        ProxyForComponentInterfaceGroup clientSideProxy = Fractive.getMulticastController(getFcItfOwner())
	                                                                                  .lookupFcMulticast(itfTypes[i].getFcItfName());

	                        //                        if (clientSideProxy == null) {
	                        //                        	System.out.println("client side proxy is null from " + ProActiveRuntimeImpl.getProActiveRuntime().getURL());
	                        //                        }
	                        if (clientSideProxy.getDelegatee().isEmpty()) {
	                            throw new IllegalLifeCycleException(
	                                "compulsory multicast client interface " +
	                                itfTypes[i].getFcItfName() + " in component " +
	                                Fractal.getNameController(getFcItfOwner())
	                                       .getFcName() + " is not bound. ");
	                        }
	                    } else if ((((ProActiveInterfaceType) itfTypes[i]).getFcCardinality()
	                                     .equals(ProActiveTypeFactory.SINGLETON_CARDINALITY) ||
	                            ((ProActiveInterfaceType) itfTypes[i]).getFcCardinality()
	                                 .equals(ProActiveTypeFactory.GATHER_CARDINALITY)) &&
	                            (Fractal.getBindingController(getFcItfOwner())
	                                        .lookupFc(itfTypes[i].getFcItfName()) == null)) {
	                        throw new IllegalLifeCycleException(
	                            "compulsory client interface " +
	                            itfTypes[i].getFcItfName() + " in component " +
	                            Fractal.getNameController(getFcItfOwner())
	                                   .getFcName() + " is not bound. ");
	                    }

	                    // check compulsory client gathercast interface in composite
	                    // add a test for client gathercast interface in composite
	                }
	            }

	            System.out.println("dentro al lifecycle");
	            
	            String hierarchical_type = Fractive.getComponentParametersController((ProActiveComponent) getFcItfOwner())
	                                               .getComponentParameters()
	                                               .getHierarchicalType();
	            if (hierarchical_type.equals(Constants.COMPOSITE)) {
	                // start all inner components
	                Component[] inner_components = Fractal.getContentController(getFcItfOwner())
	                                                      .getFcSubComponents();
	                
//	              Recupero l'AutonomicManager
	                ProActiveComponent pac_simp = null;
	                ProActiveComponent pac_am = null;
	                boolean inUse=false;
	                try {
	                	pac_simp = (ProActiveComponent) Fractive.lookup("RegistrationSimplifier");
						pac_am = (ProActiveComponent) Fractive.lookup("AutonomicManager");
						
						RegistrationSimplifier rs = 
							(RegistrationSimplifier) pac_simp.getFcInterface("server-registration-simplifier");
						
						inUse = (rs.getStartOrStopAM());
						
					} catch (IOException e) {
						e.printStackTrace();
					} catch (NamingException e) {
						e.printStackTrace();
					}
	                
					
	                if (inner_components != null) {
	                    for (int i = 0; i < inner_components.length; i++) {
	                    	if(!((ProActiveComponent)inner_components[i]).equals(pac_am) || !inUse)
	                        ((LifeCycleController) inner_components[i].getFcInterface(Constants.LIFECYCLE_CONTROLLER)).startFc();
	                    }
	                }
	            }

	            //getRequestQueue().start();
	            fcState = LifeCycleController.STARTED;
	            /*if (logger.isDebugEnabled()) {
	                logger.debug("started " +
	                    ((ComponentParametersController) getFcItfOwner()
	                     .getFcInterface(Constants.COMPONENT_PARAMETERS_CONTROLLER)).getComponentParameters()
	                     .getName());
	            }*/
	        } catch (NoSuchInterfaceException nsie) {
	            //logger.error("interface not found : " + nsie.getMessage());
	            nsie.printStackTrace();
	        } catch (IllegalLifeCycleException ilce) {
	            //logger.error("illegal life cycle operation : " + ilce.getMessage());
	            ilce.printStackTrace();
	        }
	        
	        System.out.println("esco dal lifecycle");
	    }



	@Override
	public void startFc(short arg0) {
		super.startFc(arg0);
	}
	

}
