package org.ercim.gridcomp.am.controller;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalContentException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.api.factory.GenericFactory;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.fractal.util.Fractal;

import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.component.ContentDescription;
import org.objectweb.proactive.core.component.ControllerDescription;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.ProActiveInterface;
import org.objectweb.proactive.core.component.controller.AbstractProActiveController;
import org.objectweb.proactive.core.component.controller.ComponentParametersController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.component.type.ProActiveInterfaceType;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;
import org.objectweb.proactive.core.mop.ConstructionOfReifiedObjectFailedException;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public class AutonomicCompositeControllerImpl extends AbstractProActiveController
									 implements AutonomicController{

	
	private String className = AutonomicCompositeControllerImpl.class.getSimpleName()+"> ";
	private void out(String s){	System.out.println(className+s); }
	private void err(String s){	System.err.println(className+s); }
	
	public AutonomicCompositeControllerImpl(Component owner) {
		super(owner);
		//err("CLASS:"+owner);
	}

	
	private static final long serialVersionUID = 1L;

	@Override
	protected void setControllerItfType() {
		try {
			setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(
					AutonomicController.CONTROLLER_NAME,
					AutonomicController.class.getName(),
					TypeFactory.SERVER,
					TypeFactory.OPTIONAL,
					TypeFactory.SINGLE));
		} catch (InstantiationException e) {
			throw new ProActiveRuntimeException("Cannot create controller type: " + getClass().getName());
		}
	}

	public GenericTypeWrapper execOperation(String op, Object... params) {
		// if(classe_contenuta estende/implementa AutonomicController) then inoltra-le-chiamate-alla-classe
		/*if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).execOperation(op, params);
		}
		err("Oggetto: "+owner.getReferenceOnBaseObject()+" non compatibile con l'interfaccia AutonomicController");
		*/
		
		System.out.println("PRIMA DELL IF");
		if(op.equals("increaseParallelDegree")){
		
			System.out.println("DENTRO ALL IF");
			
			ContentController ownerCC;
			try {
				ownerCC = (ContentController) owner.getFcInterface("content-controller");
				Component internal = ownerCC.getFcSubComponents()[0];
				Component newC = newComponent(internal);
				ownerCC.addFcSubComponent(newC);
				
				((LifeCycleController)newC.getFcInterface("lifecycle-controller")).stopFc();
				
				/*BindingController newCBC = (BindingController) newC.getFcInterface("binding-controller");
				for(String itf : newCBC.listFc()){
						
					System.out.println("-----------***------>"+itf);
					System.out.println(((ProActiveComponentRepresentative)((ProActiveComponent)newC).
							getRepresentativeOnThis()).
							getStubOnBaseObject().
							getClass().getSuperclass().
							getCanonicalName());
					System.out.println("-----------***------>"+owner.getFcInterface(itf));
					System.out.println(":::::::::::::::"+newCBC.lookupFc(itf));
					newCBC.unbindFc(itf);
					newCBC.bindFc(itf, owner.getFcInterface(itf));
				}*/
				
				System.out.println("prima di recuperare il binding controller: "+owner.getFcInterfaces().length);
				
				BindingController ownerBC = (BindingController) owner.getFcInterface("binding-controller");
				
				for(Interface itf : (Interface[]) owner.getFcInterfaces()){
					
					System.out.println("dentro al for: "+itf.getFcItfName());
					
					if(!((InterfaceType)itf.getFcItfType()).isFcClientItf() && !itf.getFcItfName().endsWith("-controller")){
						
						ProActiveInterface cCompCollItf = Fractive.createCollectiveClientInterface("collective-"+itf.getFcItfName(),
																								   ((InterfaceType)itf.getFcItfType()).getFcItfSignature(), 
																								   owner);
						
						System.out.println("interfaccia collettiva creata");
						
						CollectiveInterfaceDispatcherProxy mp = null;
						try {
							
							mp = new CollectiveInterfaceDispatcherProxy(((InterfaceType)itf.getFcItfType()).getFcItfSignature());
							mp.setInterfaceType((ProActiveInterfaceType)itf.getFcItfType());
							
						} catch (ConstructionOfReifiedObjectFailedException e) {
							e.printStackTrace();
						}
						
						mp.add(newC.getFcInterface(itf.getFcItfName()));
						mp.add(internal.getFcInterface(itf.getFcItfName()));
						//mp.add(toParallelize.getFcInterface(itf.getFcItfName()));
						//mp.add(toParallelize.getFcInterface(itf.getFcItfName()));
						
						cCompCollItf.setProxy(mp);
						ownerBC.unbindFc(itf.getFcItfName());
						ownerBC.bindFc(itf.getFcItfName(), cCompCollItf);
					}
				}	
					
				
			} catch (NoSuchInterfaceException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalContentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalLifeCycleException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalBindingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		
		System.out.println("terminato lavoro del controller");
		
		return null;
	}
	
	
	private int counter = 0;
	private Component newComponent(Component toParallelize) {
		
		// Retreiving Type & Component Factories
		Component boot = null;
		try {
			boot = org.objectweb.fractal.api.Fractal.getBootstrapComponent();
		} catch (InstantiationException e) {
			e.printStackTrace();
		}

		GenericFactory cf = null;
		try {
			cf = Fractal.getGenericFactory(boot);
		} catch (NoSuchInterfaceException e) {
			e.printStackTrace();
		}

		// Cloning controllers
		ControllerDescription controlDesc = null;
		try {
			controlDesc = ((ComponentParametersController) toParallelize.getFcInterface(Constants.COMPONENT_PARAMETERS_CONTROLLER)).
			getComponentParameters().
			getControllerDescription();
		} catch (NoSuchInterfaceException e) {
			e.printStackTrace();
		}

		// Creating a new Name
		NameController toParallelizeNC = null;
		try {
			toParallelizeNC = (NameController) toParallelize.getFcInterface("name-controller");
		} catch (NoSuchInterfaceException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		String name  = toParallelizeNC.getFcName()+"-autonomic-duplicate-0";
		controlDesc.setName(name);

		// Cloning content
		String clazz = ((ProActiveComponentRepresentative)toParallelize).getStubOnBaseObject().getClass().getSuperclass().getName();
		ContentDescription contentDesc = new ContentDescription(clazz);
		
		Component toParallelizeClone = null;
		try {
			toParallelizeClone = cf.newFcInstance( toParallelize.getFcType(), 
					controlDesc,
					contentDesc );
		} catch (InstantiationException e) {
			e.printStackTrace();
		}
		
		LifeCycleController tPcLCC;
		try {
			tPcLCC = (LifeCycleController) toParallelizeClone.getFcInterface("lifecycle-controller");
			tPcLCC.stopFc();
		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalLifeCycleException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		return toParallelizeClone;
		
		/*
		try {
			Component boot = org.objectweb.fractal.api.Fractal.getBootstrapComponent();
			ComponentType type = (ComponentType)toParallelize.getFcType();

			String klass = ((ProActiveComponentRepresentative)toParallelize).getStubOnBaseObject().getClass().getSuperclass().getName();
			ContentDescription contentDesc = new ContentDescription(klass);

			String name  = "autonomic-duplicate-" + (++counter);
			
			ControllerDescription controlDesc = 
				((ComponentParametersController)toParallelize.
						getFcInterface(Constants.COMPONENT_PARAMETERS_CONTROLLER)).
						getComponentParameters().
						getControllerDescription();
			
			controlDesc.setName(name);

			Component comp = ((ProActiveGenericFactory)Fractal.getGenericFactory(boot)).newFcInstance(type, controlDesc, contentDesc);
			
			return comp;
		
		} catch (Exception e) {
			e.printStackTrace();
			
		}
		
		return null;
		*/
	}
	

	public Double getBandwidth() {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).getBandwidth();
		}
		
		return 0.0;
	}

	public Integer getParallelismDegree() {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).getParallelismDegree();
		}
		return 0;
	}

	public String[] listAutonomicOperations() {
		
		/*if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).listAutonomicOperations();
		}
		err("Oggetto: "+owner.getReferenceOnBaseObject()+" non compatibile con l'interfaccia AutonomicController");
		*/
		return new String[]{"increaseParallelDegree"};
	}

	public void setBandwidth(double bandwidth) {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			((AutonomicController) owner.getReferenceOnBaseObject()).setBandwidth(bandwidth);
		}

	}

	public void setParallelismDegree(int parDegree) {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			((AutonomicController) owner.getReferenceOnBaseObject()).setParallelismDegree(parDegree);
		}
	}

}
