package org.ercim.gridcomp.am.controller;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.TypeFactory;

import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.component.controller.AbstractProActiveController;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public class AutonomicControllerImpl extends AbstractProActiveController
									 implements AutonomicController{

	
	private String className = AutonomicControllerImpl.class.getSimpleName()+"> ";
	private void out(String s){	System.out.println(className+s); }
	private void err(String s){	System.err.println(className+s); }
	
	public AutonomicControllerImpl(Component owner) {
		super(owner);
		//err("CLASS:"+owner);
	}

	
	private static final long serialVersionUID = 1L;

	@Override
	protected void setControllerItfType() {
		try {
			setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(
					AutonomicController.CONTROLLER_NAME,
					AutonomicController.class.getName(),
					TypeFactory.SERVER,
					TypeFactory.OPTIONAL,
					TypeFactory.SINGLE));
		} catch (InstantiationException e) {
			throw new ProActiveRuntimeException("Cannot create controller type: " + getClass().getName());
		}
	}

	public GenericTypeWrapper execOperation(String op, Object... params) {
		// if(classe_contenuta estende/implementa AutonomicController) then inoltra-le-chiamate-alla-classe
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).execOperation(op, params);
		}
		err("Oggetto: "+owner.getReferenceOnBaseObject()+" non compatibile con l'interfaccia AutonomicController");
		return null;
	}

	public Double getBandwidth() {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).getBandwidth();
		}
		
		return 0.0;
	}

	public Integer getParallelismDegree() {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).getParallelismDegree();
		}
		return 0;
	}

	public String[] listAutonomicOperations() {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			return ((AutonomicController) owner.getReferenceOnBaseObject()).listAutonomicOperations();
		}
		err("Oggetto: "+owner.getReferenceOnBaseObject()+" non compatibile con l'interfaccia AutonomicController");
		return null;
	}

	public void setBandwidth(double bandwidth) {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			((AutonomicController) owner.getReferenceOnBaseObject()).setBandwidth(bandwidth);
		}

	}

	public void setParallelismDegree(int parDegree) {
		if(owner.getReferenceOnBaseObject() instanceof AutonomicController){
			out("Oggetto: "+owner.getReferenceOnBaseObject().getClass().getSuperclass().getCanonicalName()+" compatibile con l'interfaccia AutonomicController");
			((AutonomicController) owner.getReferenceOnBaseObject()).setParallelismDegree(parDegree);
		}
	}

}
