package org.ercim.gridcomp.am.controller;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import java.util.Map;
import java.util.Vector;

import org.objectweb.proactive.Body;
import org.objectweb.proactive.ProActive;
import org.objectweb.proactive.core.body.LocalBodyStore;
import org.objectweb.proactive.core.component.collectiveitfs.MulticastHelper;
import org.objectweb.proactive.core.component.exceptions.ParameterDispatchException;
import org.objectweb.proactive.core.component.group.ProxyForComponentInterfaceGroup;
import org.objectweb.proactive.core.component.type.ProActiveInterfaceTypeImpl;
import org.objectweb.proactive.core.group.ExceptionListException;
import org.objectweb.proactive.core.group.ProcessForAsyncCall;
import org.objectweb.proactive.core.group.ProcessForOneWayCall;
import org.objectweb.proactive.core.group.ProxyForGroup;
import org.objectweb.proactive.core.mop.ClassNotReifiableException;
import org.objectweb.proactive.core.mop.ConstructionOfReifiedObjectFailedException;
import org.objectweb.proactive.core.mop.MOP;
import org.objectweb.proactive.core.mop.MethodCall;
import org.objectweb.proactive.core.mop.StubObject;
import org.objectweb.proactive.core.util.profiling.Profiling;

public class CollectiveInterfaceDispatcherProxy extends ProxyForComponentInterfaceGroup {

	

	public CollectiveInterfaceDispatcherProxy(String nameOfClass) throws ConstructionOfReifiedObjectFailedException {
		super(nameOfClass);
		// TODO Auto-generated constructor stub
	}

	private static final long serialVersionUID = 1L;

	@Override
	protected Object asynchronousCallOnGroup(MethodCall mc) throws InvocationTargetException {
		// TODO Auto-generated method stub
		
		System.err.println("MyPROXY: asynchronous call of: "+mc.getName());
		System.err.flush();
		Object result;
        Body body = ProActive.getBodyOnThis();
        if (Profiling.GROUP) {
            timer.setTimer("asynchronousCallOnGroup." + mc.getName());
            timer.start();
        }

        // Creates a stub + ProxyForGroup for representing the result
        String returnTypeClassName = null;
        try {
            Object[] paramProxy = new Object[0];
            Type t = mc.getReifiedMethod().getGenericReturnType();
            if (t instanceof TypeVariable) {
            	returnTypeClassName = mc.getGenericTypesMapping().get(t).getName();
            } else {
            	returnTypeClassName = mc.getReifiedMethod().getReturnType().getName();
            }

            result = MOP.newInstance(returnTypeClassName,
                    null, null, ProxyForGroup.class.getName(), paramProxy);
            
            ((ProxyForGroup) ((StubObject) result).getProxy()).setClassName(returnTypeClassName);
            
        } catch (ClassNotReifiableException e1) {
            throw new InvocationTargetException(e1, "Method " + mc.getReifiedMethod().toGenericString() + " : cannot return a group of results for the non reifiable type " + returnTypeClassName);
        } catch (Exception e2) {
        	throw new InvocationTargetException(e2, "Method " + mc.getReifiedMethod().toGenericString() + " : cannot create group of results");
        }

        int size = this.memberList.size();

        // Init the lists of result with null value to permit the "set(index)" operation
        Vector memberListOfResultGroup = ((ProxyForGroup) ((StubObject) result).getProxy()).getMemberList();
        for (int i = 0; i < size; i++) {
            memberListOfResultGroup.add(null);
        }

        // Creating Threads
        //if (isDispatchingCall(mc) == false) {
            if (uniqueSerialization) {
                mc.transformEffectiveArgumentsIntoByteArray();
            }
            for (int index = 0; index < this.memberList.size(); index++)
                this.threadpool.addAJob(new ProcessForAsyncCall(this,
                        this.memberList, memberListOfResultGroup, nextWorker(), mc,
                        body));
        /*} else { // isDispatchingCall == true
            //Object[] individualEffectiveArguments = distributeParameters(mc);
            for (int index = 0; index < memberList.size(); index++) {
                
                Object[] individualEffectiveArguments = new Object[mc.getNumberOfParameter()];
                for (int i = 0; i < mc.getNumberOfParameter(); i++)
                    if (ProActiveGroup.isScatterGroupOn(mc.getParameter(i))) {
                        individualEffectiveArguments[i] = ProActiveGroup.get(mc.getParameter(
                                    i),
                                index % ProActiveGroup.size(mc.getParameter(i)));
                    } else {
                        individualEffectiveArguments[i] = mc.getParameter(i);
                    }
                this.threadpool.addAJob(new ProcessForAsyncCall(this,
                        this.memberList, memberListOfResultGroup, index,
                        new MethodCall(mc.getReifiedMethod(), mc.getGenericTypesMapping(),
                            individualEffectiveArguments, mc.getExceptionContext()),
                        body));
            }
        }*/

        LocalBodyStore.getInstance().setCurrentThreadBody(body);
        if (Profiling.GROUP) {
            timer.stop();
        }
        return result;
	}

	@Override
	protected void oneWayCallOnGroup(MethodCall mc, ExceptionListException exceptionList) throws InvocationTargetException {
		// TODO Auto-generated method stub
		
		System.err.println("MyPROXY: one way call of: "+mc.getName());
		System.err.flush();
		
		 Body body = ProActive.getBodyOnThis();
	        if (Profiling.GROUP) {
	            timer.setTimer("oneWayCallOnGroup." + mc.getName());
	            timer.start();
	        }

	        // Creating Threads
	        //if (isDispatchingCall(mc) == false) {
	            if (uniqueSerialization) {
	                mc.transformEffectiveArgumentsIntoByteArray();
	            }
	            //for (int index = 0; index < this.memberList.size(); index++) {
	                this.threadpool.addAJob(new ProcessForOneWayCall(this,
	                        this.memberList, nextWorker()/*index*/, mc, body, exceptionList));
	            //}
	        /*} else { // isDispatchingCall == true
//	            Object[] individualEffectiveArguments = distributeParameters(mc);
	            for (int index = 0; index < memberList.size(); index++) {
	                Object[] individualEffectiveArguments = new Object[mc.getNumberOfParameter()];
	                for (int i = 0; i < mc.getNumberOfParameter(); i++)
	                    if (ProActiveGroup.isScatterGroupOn(mc.getParameter(i))) {
	                        individualEffectiveArguments[i] = ProActiveGroup.get(mc.getParameter(
	                                    i),
	                                index % ProActiveGroup.size(mc.getParameter(i)));
	                    } else {
	                        individualEffectiveArguments[i] = mc.getParameter(i);
	                    }
	                this.threadpool.addAJob(new ProcessForOneWayCall(this,
	                        this.memberList, index,
	                        new MethodCall(mc.getReifiedMethod(), mc.getGenericTypesMapping(),
	                            individualEffectiveArguments, mc.getExceptionContext()),
	                        body, exceptionList));
	            }
	        }*/

	        LocalBodyStore.getInstance().setCurrentThreadBody(body);

	        if (Profiling.GROUP) {
	            timer.stop();
	        }
	}

	private int currentWorker = 0; 
	private int nextWorker() {
		// TODO Auto-generated method stub
		return ((currentWorker++) % memberList.size());
	}

	@Override
	public synchronized Object reify(MethodCall mc) throws InvocationTargetException {
		// TODO Auto-generated method stub
		
		
		System.err.println("MyPROXY: reify of: "+mc.getName());
		System.err.flush();
		
		return super.reify(mc);
	}

	@Override
	protected void redistributeParameters(MethodCall mc) {
		// TODO Auto-generated method stub
		
		System.err.println("MyPROXY: redistributing parameters : "+mc.getName());
		System.err.flush();
		
		super.redistributeParameters(mc);
	}

	
}
