package org.ercim.gridcomp.am.controller;

import java.io.Serializable;
import java.util.Collections;
import java.util.Vector;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.AbstractProActiveController;
import org.objectweb.proactive.core.component.controller.ProActiveContentController;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public class CompositeMembraneAutonomicControllerImpl extends AbstractProActiveController 
implements CompositeMembraneAutonomicController, Serializable  {

	private static final long serialVersionUID = 1L;
	
	public CompositeMembraneAutonomicControllerImpl(Component owner) {
		super(owner);
	}

	@Override
	protected void setControllerItfType() {
		try {
			setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(
					CompositeMembraneAutonomicController.MEMBRANE_AUTONOMIC_CONTROLLER_NAME,
					CompositeMembraneAutonomicController.class.getName(),
					TypeFactory.SERVER,
					TypeFactory.MANDATORY,
					TypeFactory.SINGLE));
		} catch (InstantiationException e) {
			throw new ProActiveRuntimeException("Cannot create controller type: " + getClass().getName());
		}

	}

	public GenericTypeWrapper execOperation(String op, Object... params) {
		// TODO Auto-generated method stub
		return null;
	}

	public String[] listAutonomicOperations() {
		// TODO Auto-generated method stub
		
		System.err.println("NELLA LIST DEL COMPOSITE");
		
		ProActiveContentController pacc= null;
		try {
			pacc = Fractive.getProActiveContentController(owner);
		} catch (NoSuchInterfaceException e) {
			e.printStackTrace();
			return null;
		}
		
		Vector<String> listOps = new Vector<String>();
		Component[] innerComps = pacc.getFcSubComponents();
		for(Component cmp : innerComps){
			try{
				AutonomicController ac = (AutonomicController) cmp.getFcInterface("autonomic-controller");
				Collections.addAll(listOps, ac.listAutonomicOperations());
			}catch(NoSuchInterfaceException nsie){
				
			}
		}
		
		return listOps.toArray(new String[listOps.size()]);
	}


}
