package org.ercim.gridcomp.am.example;

import org.ercim.gridcomp.am.example.Compute;
import org.ercim.gridcomp.am.example.Task;
import org.ercim.gridcomp.am.controller.AutonomicController;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;
import org.objectweb.proactive.core.util.wrapper.StringWrapper;

public class Consumer implements Compute, AutonomicController 
{
	private static final long serialVersionUID = 772858459599754350L;
	
	private int parDegree = 1;
	//private String header = "";
	
	public Consumer() {}
	
	public void compute(Task task)
	{
		System.out.println("Consumer compute: "+task.id);
	}
	

	public Double getBandwidth() {
		
		double delta = 1.01 - (parDegree/100.0);
		System.out.println("Stage-> Delta vale:"+ delta);
		return ( 600.0 / (parDegree *  delta));
	}

	public void setBandwidth(double bandwidth) {
		
		// System.out.println("Stage -> Settata correzione di banda a:"+bandwidth);
	}

	public Integer getParallelismDegree() {
		return parDegree;
	}

	public void setParallelismDegree(int parDeg) {
		parDegree = parDeg;
	}

	public GenericTypeWrapper execOperation(String op, Object... params) {
		
		if(op.equals("getParallelismDegree"))
			return new GenericTypeWrapper<Integer>(getParallelismDegree());
		if(op.equals("setParallelismDegree"))
			setParallelismDegree((Integer)params[0]);
		if(op.equals("getBandwidth"))
			return new GenericTypeWrapper<Double>(getBandwidth());
		if(op.equals("setBandwidth"))
			setBandwidth((Double)params[0]);
		return null;
	}

	public String[] listAutonomicOperations() {
		return new String[]{"ParallelismDegree", "Bandwidth"};
	}

	public StringWrapper name() {
		// TODO Auto-generated method stub
		return new StringWrapper("Consumer--Wrapped");
	}

	public String nameNotWrapped() {
		// TODO Auto-generated method stub
		return "Consumer--Not--Wrapped";
	}
}
