package org.ercim.gridcomp.am.example;


import org.ercim.gridcomp.am.example.Compute;
import org.ercim.gridcomp.am.example.Task;
import org.ercim.gridcomp.am.controller.AutonomicController;

import java.io.Serializable;
import java.util.Random;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.Body;
import org.objectweb.proactive.RunActive;
import org.objectweb.proactive.Service;

import org.objectweb.proactive.core.component.ProActiveInterface;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public class Producer implements RunActive, BindingController, AutonomicController
{
	private Compute nextStage;
	private int parDegree = 1;
	private int var = 1;
	
	private int i = 1;
	
	public Producer() {}
	
	public void runActivity(Body body) 
	{
		Service serv = new Service(body);
		while(serv.hasRequestToServe()){
				serv.serveOldest();
		}
		
		
		Random gen = new Random();
		Task task = generate(gen,i++);
		nextStage.compute(task);
		//nextStage.name();
		//nextStage.nameNotWrapped();
		try {
			if(i%2 == 0){				
				//Class[] clss = nextStage.getClass().getInterfaces();
				
				/*for(Class c : clss){
					System.out.println("-> "+c.getName());
				}*/
				
				if(((ProActiveComponentRepresentative)((ProActiveInterface)nextStage).getFcItfOwner()).getStubOnBaseObject() instanceof AutonomicController){
					System.out.println("OK***********");
				}
			}
			Thread.sleep(500);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
	}

	// CONFIGURATION
	public void bindFc(String clientItfName, Object serverItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
	{
		if (clientItfName.equals(Compute.CLIENT_ITF_NAME)) 
			nextStage = (Compute)serverItf;
		else 
			throw new NoSuchInterfaceException(clientItfName);
	}

	public String[] listFc() 
	{
		return new String[] {
			Compute.CLIENT_ITF_NAME
		};
	}

	public Object lookupFc(String clientItfName) throws NoSuchInterfaceException 
	{
		if (clientItfName.equals(Compute.CLIENT_ITF_NAME)) 
			return nextStage;
		throw new NoSuchInterfaceException(clientItfName);
	}

	public void unbindFc(String clientItfName) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException 
	{
		if (clientItfName.equals(Compute.CLIENT_ITF_NAME)) 
			nextStage = null;
		else 
			throw new NoSuchInterfaceException(clientItfName);
	}
	
	private Task generate(Random gen, int id)
	{
		double[] data = new double[1000];
		for (int j = 0; j < data.length; j++)
			data[j] = gen.nextDouble();
		double tmp = data[0];
		for (int j = 0; j < data.length - 1; j++)
			data[j] *= data[j+1];
		data[data.length-1] *= tmp;
		return new Task(id, data);
	}


	public Double getBandwidth() {
		
		double delta = 1.01 - (parDegree/100.0);
		System.out.println("Stage-> Delta vale:"+ delta);
		return ( 800.0 / (parDegree *  delta));
	}

	public void setBandwidth(double bandwidth) {
		
	}

	public Integer getParallelismDegree() {
		return parDegree;
	}

	public void setParallelismDegree(int parDeg) {
		parDegree = parDeg;
	}

	public String getFcState() {
		return null;
	}

	public GenericTypeWrapper execOperation(String op, Object... params) {
		
		if(op.equals("getParallelismDegree"))
			return new GenericTypeWrapper<Integer>(getParallelismDegree());
		if(op.equals("setParallelismDegree"))
			setParallelismDegree((Integer)params[0]);
		if(op.equals("getBandwidth"))
			return new GenericTypeWrapper<Double>(getBandwidth());
		if(op.equals("setBandwidth"))
			setBandwidth((Double)params[0]);
		return null;
	}

	public String[] listAutonomicOperations() {
		return new String[]{"ParallelismDegree", "Bandwidth"};
	}

}
