package org.ercim.gridcomp.component.autonomic.controller;

import org.ercim.gridcomp.component.autonomic.controller.itf.AutonomicController;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.proactive.core.ProActiveRuntimeException;
import org.objectweb.proactive.core.component.controller.AbstractProActiveController;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactoryImpl;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

public abstract class AbstractAutonomicController extends AbstractProActiveController
												  implements AutonomicController {

	public AbstractAutonomicController(Component owner) {
		super(owner);
	}
	

	@Override
	protected void setControllerItfType() {
		try {
			setItfType(ProActiveTypeFactoryImpl.instance().createFcItfType(
					AutonomicController.CONTROLLER_NAME,
					AutonomicController.class.getName(),
					TypeFactory.SERVER,
					TypeFactory.OPTIONAL,
					TypeFactory.SINGLE));
		} catch (InstantiationException e) {
			throw new ProActiveRuntimeException("Cannot create controller type: " + getClass().getName());
		}
	}

	public abstract GenericTypeWrapper execOperation(String op, Object... params);

	public abstract String[] listAutonomicOperations();

}
