package org.ercim.gridcomp.component.autonomic.manager;

import java.util.Vector;

import org.ercim.gridcomp.component.autonomic.manager.itf.AutonomicClientManager;
import org.ercim.gridcomp.component.autonomic.manager.itf.AutonomicServerManager;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.util.Fractal;

import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ComponentParametersController;
import org.objectweb.proactive.core.component.controller.ProActiveLifeCycleControllerImpl;
import org.objectweb.proactive.core.component.group.ProxyForComponentInterfaceGroup;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.component.type.ProActiveInterfaceType;
import org.objectweb.proactive.core.component.type.ProActiveTypeFactory;


public class AutonomicComponentLCC extends ProActiveLifeCycleControllerImpl {

	private static final long serialVersionUID = 2383103386061804312L;
	
	public AutonomicComponentLCC(Component arg0) {
		super(arg0);		
	}

	
	public void autonomicStopFc() {

		try {
			String hierarchical_type = ((ComponentParametersController) getFcItfOwner()
					.getFcInterface(Constants.COMPONENT_PARAMETERS_CONTROLLER)).getComponentParameters()
					.getHierarchicalType();
			if (hierarchical_type.equals(Constants.COMPOSITE)) {
				// stop all inner components
				Component[] inner_components = ((ContentController) getFcItfOwner()
						.getFcInterface(Constants.CONTENT_CONTROLLER)).getFcSubComponents();

				Component[] functionalComponents = filter(inner_components);
				
				/*boolean inUse=true;
				//inUse = (auxiliaryManager.isReconfiguring());
				if(inUse)*/
					for (int i = 0; i < functionalComponents.length; i++) {
						((LifeCycleController) functionalComponents[i].getFcInterface(Constants.LIFECYCLE_CONTROLLER)).stopFc();
					}
				/*else
					for (int i = 0; i < inner_components.length; i++) {
						((LifeCycleController) inner_components[i].getFcInterface(Constants.LIFECYCLE_CONTROLLER)).stopFc();
					}*/
			}

			//getRequestQueue().stop();
			fcState = LifeCycleController.STOPPED;
		
		} catch (NoSuchInterfaceException nsie) {
		
		} catch (IllegalLifeCycleException ilce) {
			
		}
	}


	private Component[] filter(Component[] inner_components) {
		
		Vector<Component> vCmp = new Vector<Component>();
		
		for(Component cmp : inner_components){
			
			Object baseObject = null;
			if(cmp instanceof ProActiveComponentRepresentative) 
				baseObject = ((ProActiveComponentRepresentative) cmp).getStubOnBaseObject();
			else
				baseObject = ((ProActiveComponent) cmp).getReferenceOnBaseObject();
			
			
			if((baseObject instanceof AutonomicServerManager) || (baseObject instanceof AutonomicClientManager))
				continue;
			
			else 
				vCmp.add(cmp);
		}
		
		if(vCmp.size() == 0) 
			return null;
		else
			return vCmp.toArray(new Component[vCmp.size()]);
	}

	@Override
	public void stopFc(short arg0) {

	}


	//boolean inUseStart=false;
	
	public void autonomicStartFc() {
		try {
			//check that all mandatory client interfaces are bound
			//            Object[] itfs = getFcItfOwner().getFcInterfaces();
			InterfaceType[] itfTypes = ((ComponentType) getFcItfOwner()
					.getFcType()).getFcInterfaceTypes();

			for (int i = 0; i < itfTypes.length; i++) {
				if (itfTypes[i].isFcClientItf() &&
						!itfTypes[i].isFcOptionalItf()) {
					if (itfTypes[i].isFcCollectionItf()) {
						// look for collection members
						Object[] itfs = owner.getFcInterfaces();
						for (int j = 0; j < itfs.length; j++) {
							Interface itf = (Interface) itfs[j];
							if (itf.getFcItfName()
									.startsWith(itfTypes[i].getFcItfName())) {
								if (itf.getFcItfName()
										.equals(itfTypes[i].getFcItfName())) {
									throw new IllegalLifeCycleException(
											"invalid collection interface name at runtime (suffix required)");
								}
								if (Fractal.getBindingController(owner)
										.lookupFc(itf.getFcItfName()) == null) {
									throw new IllegalLifeCycleException(
											"compulsory collection client interface " +
											itfTypes[i].getFcItfName() +
											" in component " +
											Fractal.getNameController(
													getFcItfOwner()).getFcName() +
													" is not bound. ");
								}
							}
						}
					} else if (((ProActiveInterfaceType) itfTypes[i]).isFcMulticastItf() &&
							!!itfTypes[i].isFcOptionalItf()) {
						ProxyForComponentInterfaceGroup clientSideProxy = Fractive.getMulticastController(getFcItfOwner())
						.lookupFcMulticast(itfTypes[i].getFcItfName());
						
						if (clientSideProxy.getDelegatee().isEmpty()) {
							throw new IllegalLifeCycleException(
									"compulsory multicast client interface " +
									itfTypes[i].getFcItfName() + " in component " +
									Fractal.getNameController(getFcItfOwner())
									.getFcName() + " is not bound. ");
						}
					} else if ((((ProActiveInterfaceType) itfTypes[i]).getFcCardinality()
							.equals(ProActiveTypeFactory.SINGLETON_CARDINALITY) ||
							((ProActiveInterfaceType) itfTypes[i]).getFcCardinality()
							.equals(ProActiveTypeFactory.GATHER_CARDINALITY)) &&
							(Fractal.getBindingController(getFcItfOwner())
									.lookupFc(itfTypes[i].getFcItfName()) == null)) {
						throw new IllegalLifeCycleException(
								"compulsory client interface " +
								itfTypes[i].getFcItfName() + " in component " +
								Fractal.getNameController(getFcItfOwner())
								.getFcName() + " is not bound. ");
					}

					// check compulsory client gathercast interface in composite
					// add a test for client gathercast interface in composite
				}
			}

			String hierarchical_type = Fractive.getComponentParametersController((ProActiveComponent) getFcItfOwner())
			.getComponentParameters()
			.getHierarchicalType();
			if (hierarchical_type.equals(Constants.COMPOSITE)) {
				
				// starts inner components
				Component[] inner_components = Fractal.getContentController(getFcItfOwner()).getFcSubComponents();
				Component[] functionalComponents = filter(inner_components);
				
				
				
				//LifeCycleController auxLCC = (LifeCycleController) (auxComp.getFcInterface(Constants.LIFECYCLE_CONTROLLER));
				//if(auxLCC.getFcState().equals(LifeCycleController.STOPPED))
				//auxLCC.startFc();
				
				//inUse = (auxiliaryManager.isReconfiguring());
				//if(inUseStart)
					for (int i = 0; i < functionalComponents.length; i++) {
						((LifeCycleController) functionalComponents[i].getFcInterface(Constants.LIFECYCLE_CONTROLLER)).startFc();
					}
				/*else{
					for (int i = 0; i < inner_components.length; i++) {
						((LifeCycleController) inner_components[i].getFcInterface(Constants.LIFECYCLE_CONTROLLER)).startFc();
					}
					
					inUseStart = true;
				}*/
			}

			//getRequestQueue().start();
			fcState = LifeCycleController.STARTED;
			
		} catch (NoSuchInterfaceException nsie) {
			
			nsie.printStackTrace();
		} catch (IllegalLifeCycleException ilce) {
			
			ilce.printStackTrace();
		}

	}

	@Override
	public void startFc(short arg0) {
		super.startFc(arg0);
	}


}
