package org.ercim.gridcomp.component.autonomic.controller;

import org.ercim.gridcomp.component.autonomic.controller.itf.AutonomicController;

import org.objectweb.fractal.api.Component;

import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;


public class AutonomicControllerForLegacyImpl extends AbstractAutonomicController {

	private static final long serialVersionUID = 3736886822335618937L;

	private Object baseObject = null;
	private String className = AutonomicControllerForLegacyImpl.class.getSimpleName();
	
	private void err(String s){	System.err.println(className+"> "+s); }
	
	public AutonomicControllerForLegacyImpl(Component owner) {
		super(owner);
		if(owner instanceof ProActiveComponentRepresentative) 
			baseObject = ((ProActiveComponentRepresentative) owner).getStubOnBaseObject();
		else
			baseObject = this.owner.getReferenceOnBaseObject();	
	}

	public GenericTypeWrapper execOperation(String op, Object... params) {
	
		if(baseObject instanceof AutonomicController){
			return ((AutonomicController) baseObject).execOperation(op, params);
		}
		err("Class: "+baseObject+" does not implements AutonomicController interface");
		return null;
	}

	public String[] listAutonomicOperations() {
		if(baseObject instanceof AutonomicController){
			return ((AutonomicController) baseObject).listAutonomicOperations();
		}
		err("Class: "+baseObject+" does not implements AutonomicController interface");
		return null;
	}

}
