package passivefarm.impls;



import java.util.Vector;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.core.util.wrapper.IntWrapper;

import passivefarm.itfs.ServerItf;
import passivefarm.itfs.Tester;


public class TesterImpl implements Tester, BindingController {

	ServerItf clientItf;

	public void testItf(int paramSize, int jobNumber) {

		Vector<Integer> parameter = new Vector<Integer>(paramSize);
		for(int i=0;i<paramSize;i++) parameter.add(paramSize - i);
		
		IntWrapper results[] = new IntWrapper[jobNumber];
		for(int i=0;i<jobNumber;i++){
			parameter.set(0, i);
			results[i] = clientItf.compute(parameter);
		}
		
		int realResults[] = new int[jobNumber];
		for(int i=0;i<jobNumber;i++){
			realResults[i] = results[i].intValue();
		}
		
		long result = 0;
		for(int i=0;i<jobNumber;i++){
			result += realResults[i];
		}
		
	}

	public void bindFc(String clientItfName, Object serverItf)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {

		if (clientItfName.equals("collectiveClientItf")) {
				clientItf = (ServerItf) serverItf;
		}else {
			throw new NoSuchInterfaceException(clientItfName);
		}
	}

	public String[] listFc() {
		return new String[]{"collectiveClientItf"};
	}

	public Object lookupFc(String clientItfName)
			throws NoSuchInterfaceException {

		if ("collectiveClientItf".equals(clientItfName)) {
			return clientItf;
		}
		throw new NoSuchInterfaceException(clientItfName);
	}
	
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {
	}
}
