package map.impls;

import java.util.HashMap;
import java.util.Map;

import org.ercim.gridcomp.am.controller.AutonomicController;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ProActiveContentController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

import map.itfs.Tester;
import nonregressiontest.component.ComponentTest;


public class Test extends ComponentTest {
    
    public static final String MESSAGE = "-Main-";
    public static final int NB_CONNECTED_ITFS = 2;


    /*
     * @see testsuite.test.FunctionalTest#action()
     */
    @Override
    public void action() throws Exception {

        Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
        Map context = new HashMap();
        
        String actualtestcase = "";
        // testcase with an internal component devoted to expose the gathercast interface 
        actualtestcase = new String("map.testcaseConGathercast");
        
        // testcase with no gathering interfaces 
        actualtestcase = new String("map.testcase");
        
        //Component testcase = (Component) f.newComponent(actualtestcase,context);
        Component testcase = (Component) f.newComponent(actualtestcase,context);
        
        /* Il problema di questa versione e' che servirebbe poter applicare una fz di redistribuzione
         * come accade per il multicast, ma per la versione 3.2 del manuale, questa funzionalita' non
         * e' ancora implementata!
        Component testcase = (Component) f.newComponent("map.testcaseMultCONGath",context);
        */
        
        Fractal.getLifeCycleController(testcase).startFc();
       
        ((Tester)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf();
       // ((Tester)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf();
       // ((Tester)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf();
        
        if (actualtestcase.equals("map.testcaseConGathercast")){
        		System.out.println("\nEnd of test..............");
        		System.exit(0);
        }
        System.exit(0);
        ProActiveContentController testcaseCC = Fractive.getProActiveContentController(testcase);
        Component[] testcaseInternalComponents = testcaseCC.getFcSubComponents();
        
        int i = 0;
        boolean found = false;
        ProActiveComponent paCmp = null;
        
        while(!found){
        	Component cmp = testcaseInternalComponents[i++];
        	if(cmp instanceof ProActiveComponent){
        		ProActiveComponentRepresentative pcr = 
        			(ProActiveComponentRepresentative)((ProActiveComponent) cmp).getRepresentativeOnThis();
        		
        		if(pcr.getStubOnBaseObject() instanceof org.objectweb.proactive.core.component.type.Composite){
        			System.out.println(pcr.getStubOnBaseObject().getClass().getSuperclass());
        			paCmp = (ProActiveComponent) testcaseInternalComponents[--i];
        			found = true;
        		}
        	}
        	
        }
        
        AutonomicController ac = (AutonomicController)paCmp.getFcInterface("autonomic-controller");
        String[] ops = ac.listAutonomicOperations();
        System.out.println("Operations from autonomic controller:");
        for(String s : ops)
        		System.out.println("\t>>"+s);
        
        Thread.sleep(10000);
        System.out.println("----------------------- First increasing -----------------------------");
        
       // System.out.println("Statistica="+((GenericTypeWrapper)ac.execOperation("statistics", new Object[0])).getObject());
        ac.execOperation("increaseParallelDegree", new Object[0]);
        
        Thread.sleep(20000);
        ((Tester)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf();
        
        Thread.sleep(10000);
        System.out.println("----------------------- Second increasing -----------------------------");
      //  System.out.println("Statistica="+((GenericTypeWrapper)ac.execOperation("statistics", new Object[0])).getObject());
        ac.execOperation("increaseParallelDegree", new Object[0]);
        
        
        ((Tester)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf();
     //   System.out.println("Statistica="+((GenericTypeWrapper)ac.execOperation("statistics", new Object[0])).getObject());
        
       
    }

    /*
     * @see testsuite.test.AbstractTest#endTest()
     */
    @Override
    public void endTest() throws Exception {

        // TODO Auto-generated method stub
        
    }

    /*
     * @see testsuite.test.AbstractTest#initTest()
     */
    @Override
    public void initTest() throws Exception {

        // TODO Auto-generated method stub
        
    }
    
    public static void main(String[] args) {
      
        System.setProperty("nonregressiontest.descriptor.defaultnodes.file", "/nonregressiontest/descriptor/defaultnodes/NodesLocal.xml");
        Test test = new Test();
        try {
            test.action();
            if (test.postConditions()) {
                System.out.println("TEST SUCCEEDED");
            } else {
                System.out.println("TEST FAILED");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
