package multicusecase;

import java.util.HashMap;
import java.util.Map;

import org.ercim.gridcomp.am.controller.AutonomicController;
import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.core.component.Fractive;
import org.objectweb.proactive.core.component.controller.ProActiveContentController;
import org.objectweb.proactive.core.component.identity.ProActiveComponent;
import org.objectweb.proactive.core.component.representative.ProActiveComponentRepresentative;
import org.objectweb.proactive.core.util.wrapper.GenericTypeWrapper;

import multicusecase.itf.Producer;
import nonregressiontest.component.ComponentTest;


public class Test extends ComponentTest {
    
    public static final String MESSAGE = "-Main-";
    public static final int NB_CONNECTED_ITFS = 2;
    public void action() throws Exception {

        Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
        Map context = new HashMap();
        
        String actualtestcase = "";
      
        System.out.println("*******************************************************");
        System.out.println("    Use of the multicast interface example             ");
        System.out.println("*******************************************************");

        // testcase with no gathering interfaces 
        actualtestcase = new String("multicusecase.adl.testcase");
        
        Component testcase = (Component) f.newComponent(actualtestcase,context);
        
        Fractal.getLifeCycleController(testcase).startFc();
       
        // the second group of values computes faster
        ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(1);
        ((Producer)testcase.getFcInterface("runTestItf")).testConnectedServerMulticastItf(100);
        

    }

    public void endTest() throws Exception {
   		    }

    public void initTest() throws Exception {
    		
    }
    
    public static void main(String[] args) {
    		System.setProperty("nonregressiontest.descriptor.defaultnodes.file", "/nonregressiontest/descriptor/defaultnodes/NodesLocal.xml");
        Test test = new Test();
        try {
            test.action();
            if (test.postConditions()) {
                System.out.println("TEST SUCCEEDED");
            } else {
                System.out.println("TEST FAILED");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
