package multicusecase.impl;
import java.util.Random;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.proactive.ProActive;
import org.objectweb.proactive.core.UniqueID;
import testsuite.test.Assertions;
import multicusecase.impl.WrappedInteger;
import multicusecase.itf.CollectorItf;
import multicusecase.itf.ServerTestItf;
import nonregressiontest.component.Message;


public class ServerImpl implements ServerTestItf, BindingController {
     
   
    private UniqueID myid;
    
    CollectorItf clientItf;
    
    public ServerImpl(){
    		myid=ProActive.getBodyOnThis().getID();

    }
    public Message processOutputMessage(Message message) {
        return null;
    }

    public WrappedInteger testOneToOne_Param(WrappedInteger a) {

        Assertions.assertEquals(a.getIntValue(), myid);
        return new WrappedInteger(0);
    }

    private int doSomething(int value){
    		double b=0.0;	
    		
    		
    		try {
			int iterations = (5000*value);
			double c = 1.0;
			
			for (int i=0;i<iterations;i++){
				
				b = (new Random(iterations)).nextDouble();
				c = c * Math.log(iterations % 100) * b;
			}
			b = c;
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    		return (value);
    }
    
    public void testRoundRobin_Param(WrappedInteger a) {
    		int value = a.getIntValue();
    		int newvalue = doSomething(value)*10;
    		WrappedInteger w = new WrappedInteger(newvalue);
    		System.out.println("[Worker] Received value="+value+", produced output="+newvalue);
    		clientItf.collectData(w);
    	}

    public void testRoundRobin_Method(WrappedInteger a) {
    		testRoundRobin_Param(a);
    }

    /*
     * @see collectiveitf.multicast.Itf1#dispatch(collectiveitf.multicast.WrappedInteger)
     */
    public WrappedInteger dispatch(WrappedInteger a) {

        return testOneToOne_Param(a);
    }

	public void bindFc(String clientItfName, Object serverItf)	throws NoSuchInterfaceException, 
																IllegalBindingException,
																IllegalLifeCycleException 
	{
		if (clientItfName.equals("CollectorItf")) {
			clientItf = (CollectorItf) serverItf;
		}
		else {
			throw new NoSuchInterfaceException(clientItfName);
		}
}

/*
* @see org.objectweb.fractal.api.control.BindingController#listFc()
*/
public String[] listFc() {

// TODO Auto-generated method stub
return null;
}

/*
* @see org.objectweb.fractal.api.control.BindingController#lookupFc(java.lang.String)
*/
public Object lookupFc(String clientItfName)
	throws NoSuchInterfaceException {

if ("CollectorItf".equals(clientItfName)) {
	return clientItf;
}

throw new NoSuchInterfaceException(clientItfName);

}

/*
* @see org.objectweb.fractal.api.control.BindingController#unbindFc(java.lang.String)
*/
public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
	IllegalBindingException, IllegalLifeCycleException {

// TODO Auto-generated method stub

}
    
}
